HDU-1506 (POJ-2599) Largest Rectangle in a Histogram (单调栈)

来源:互联网 发布:批量修改图片大小软件 编辑:程序博客网 时间:2024/05/10 00:00

Largest Rectangle in a Histogram

http://acm.hdu.edu.cn/showproblem.php?pid=1506

http://poj.org/problem?id=2559

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)


Problem Description
A histogram is a polygon composed of a sequence of rectangles aligned at a common base line. The rectangles have equal widths but may have different heights. For example, the figure on the left shows the histogram that consists of rectangles with the heights 2, 1, 4, 5, 1, 3, 3, measured in units where 1 is the width of the rectangles:

Usually, histograms are used to represent discrete distributions, e.g., the frequencies of characters in texts. Note that the order of the rectangles, i.e., their heights, is important. Calculate the area of the largest rectangle in a histogram that is aligned at the common base line, too. The figure on the right shows the largest aligned rectangle for the depicted histogram.
 

Input
The input contains several test cases. Each test case describes a histogram and starts with an integer n, denoting the number of rectangles it is composed of. You may assume that 1 <= n <= 100000. Then follow n integers h1, ..., hn, where 0 <= hi <= 1000000000. These numbers denote the heights of the rectangles of the histogram in left-to-right order. The width of each rectangle is 1. A zero follows the input for the last test case.
 

Output
For each test case output on a single line the area of the largest rectangle in the specified histogram. Remember that this rectangle must be aligned at the common base line.
 

Sample Input
7 2 1 4 5 1 3 34 1000 1000 1000 10000
 

Sample Output
84000

以前看过dp的解法,求区间的原理和单调栈差不多,但是得扫2遍

理解了单调栈及其应用的问题后,发现这些问题都变的好简单


#include <cstdio>#include <algorithm>using namespace std;int n,w,h[100005],top;long long ans;struct Node {    int h,sta;//sta表示高度h的起始下标}s[100005];int main() {    while(scanf("%d",&n),n!=0) {        for(int i=1;i<=n;++i) {            scanf("%d",h+i);        }        h[++n]=-1;//令最后一个元素的下一个高度为-1,避免循环完毕后还要弹出栈中所有元素        s[0].h=-1;        s[0].sta=top=0;        ans=0;        for(int i=1;i<=n;++i) {            if(h[i]>=s[top].h) {                s[++top].h=h[i];                s[top].sta=i;//其起始下标就是自己的下标            }            else {                while(h[i]<s[top].h) {                    ans=max(ans,1LL*(i-s[top].sta)*s[top].h);                    --top;//弹出栈顶元素                }                s[++top].h=h[i];//其起始下标是弹出的最后一个元素的起始下标            }        }        printf("%I64d\n",ans);    }    return 0;}


0 0
原创粉丝点击